#include <iostream>

using namespace std;

int main()
{
    int t ;
    cin >> t ;
    for(int k=0 ; k<t ; k++){
        int n ;
        cin >> n ;
        int a[n] ;
        int b[n] ;
        int bv[n] ;
        int br0=0 ;
        int ind1 ;
        int ind2 ;
        int br1 ;
        int br2 ;
        int br3 ;
        int br4 ;
        int br21 ;
        int br22 ;
        int br23 ;
        int br24 ;
        for(int i=0 ; i<n ; i++ ){
            cin >> a[i] ;
            if(a[i]==0){
                br0++ ;
            }
            else{
                ind1=i ;
            }
            if(a[i]==1){
                if(i%2==0){
                br1++ ;
                }
                else{
                br2++ ;
                }
            }
            else{
              if(i%2==0){
                br3++ ;
                }
              else{
                br4++ ;
              }
            }
        }
        for(int i=0 ; i<n ; i++){
            cin >> b[i] ;
            if(b[i]!=0){
                ind2=i ;
            }
           if(a[i]==1){
                if(i%2==0){
                br21++ ;
                }
                else{
                br22++ ;
                }
            }
            else{
              if(i%2==0){
                br23++ ;
                }
              else{
                br24++ ;
              }
            }
        }
        if(br0=n-1){
            if(a[ind1]==b[ind2]){
                if(ind1%2==ind2%2){
                    cout << "DA" << endl ;
                }
                else{
                    cout << "NE" << endl ;
                }
            }
            else if(a[ind1]==-b[ind2]){
                 if(ind1%2!=ind2%2){
                    cout << "DA" << endl ;
                }
                else{
                    cout << "NE" << endl ;
                }
            }
            else{
                cout << "NE" << endl ;
            }
        }
        else{
            if(br1+br3==br21+br23 && br2+br4==br22+br24){
                cout << "DA" ;
            }
            else{
                cout << "NE" ;
            }
        }
    }
    return 0;
}